﻿using DotPrologTest.Execution;
using DotPrologTest.Predicates;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.DotProlog.Code;
using OpcLabs.DotProlog.Loading;
using OpcLabs.DotProlog.Terms;
using OpcLabs.DotProlog.Test;

namespace DotPrologTest.Libraries
{
    // ReSharper disable once InconsistentNaming
    public class listsTest
    {
        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class member_2_Test : PredicateTest
        {
            public member_2_Test() : base("member", 2)
            {
            }

            [TestMethod]
            public void Test1()
            {
                var element = new Variable();
                TestPredicate(
                    element, 
                    new NList { "a", "b"}, 
                    new []
                    {
                        new VariableDictionary {{ element, Atom.Add("a")}},
                        new VariableDictionary {{ element, Atom.Add("b")}},
                    });
            }

            protected override IProgram CreateProgram()
            {
                var loader = new Loader();
                loader.ConsultLibrary("lists");

                return new Program(new Module(loader.Database));
            }
        }
    }
}
