﻿using System;
using System.ComponentModel;
using System.Runtime.Serialization;
using JetBrains.Annotations;

namespace OpcLabs.BaseLibFactory.ComponentModel
{
    [Serializable]
    class TestComponent
        : Component
        , ISerializable
    {
        // ReSharper disable once UnusedParameter.Local
        // ReSharper disable once MemberCanBeMadeStatic.Local
        private bool Equals(TestComponent other)
        {
            return true;
        }

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            // ReSharper disable once ConvertIfStatementToReturnStatement
            if (obj.GetType() != /*this.*/GetType()) return false;
            return Equals((TestComponent)obj);
        }

        /// <inheritdoc cref="object.GetHashCode()"/>
        public override int GetHashCode()
        {
            return 0;
        }

        public TestComponent()
        {
        }

        protected TestComponent([NotNull] SerializationInfo info, StreamingContext context)
        {
        }

        public void GetObjectData(SerializationInfo info, StreamingContext context)
        {
        }
    }
}
