﻿using System.Linq;
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace OpcLabs.UnitTestLib
{
    static public class TestMethodExtension
    {
        static public void AddTestCategory([NotNull] this TestMethod testMethod, [NotNull] string testCategory)
        {
            testMethod.TestCategoryAttributes.Add(new TestCategoryAttribute(testCategory));
        }

        static public bool HasTestCategory([NotNull] this TestMethod testMethod, [NotNull] string testCategory)
        {
            // ReSharper disable PossibleNullReferenceException
            return testMethod.TestCategoryAttributes.Any(attribute => attribute.TestCategories.Contains(testCategory));
            // ReSharper restore PossibleNullReferenceException
        }
    }
}
