﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.ComponentModel.Referencing;

namespace OpcLabs.BaseLibTest.ComponentModel
{
    [TestClass]
    public class ElementPathTest
    {
        [TestMethod]
        public void ElementsFromPathTest1()
        {
            IEnumerable<string> result = ElementPath.ElementsFromPath("");
            Assert.IsTrue(result.SequenceEqual(Enumerable.Empty<string>()));
        }

        [TestMethod]
        public void ElementsFromPathTest2()
        {
            IEnumerable<string> result = ElementPath.ElementsFromPath("Identifier1");
            Assert.IsTrue(result.SequenceEqual(new[] {"Identifier1"}));
        }

        [TestMethod]
        public void ElementsFromPathTest3()
        {
            IEnumerable<string> result = ElementPath.ElementsFromPath("Identifier1.Identifier2");
            Assert.IsTrue(result.SequenceEqual(new[] { "Identifier1", "Identifier2" }));
        }

        [TestMethod]
        public void ElementsFromPathTest4()
        {
            IEnumerable<string> result = ElementPath.ElementsFromPath("Identifier1(Type.Specifier)");
            Assert.IsTrue(result.SequenceEqual(new[] { "Identifier1(Type.Specifier)" }));
        }

        [TestMethod]
        public void ElementsFromPathTest5()
        {
            IEnumerable<string> result = ElementPath.ElementsFromPath("Identifier1.Identifier2(Type.Specifier)");
            Assert.IsTrue(result.SequenceEqual(new[] { "Identifier1", "Identifier2(Type.Specifier)" }));
        }

    }
}
