﻿
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpcLiveTest.DataAccess.Environment;

namespace OpcLabs.EasyOpcLiveTest.DataAccess
{
    // ReSharper disable once InconsistentNaming
    partial class EasyDAClientTest_Xml
    {
        [DynamicData(nameof(OpcFoundation_XmlDaSampleServer.ReadableItemCatalogEntryDataRows), typeof(OpcFoundation_XmlDaSampleServer))]
        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("TimeDomain")]
        [TestMethod]
        public void SubscribeItemCatalogTest_Xml_Basic([NotNull] DAItemCatalogEntry itemCatalogEntry)
        {
            SubscribeItemCatalogTest_Basic(DALiveTestEnvironment.OpcFoundation_XmlDaSampleServer.ServerDescriptors.Http, itemCatalogEntry);
        }

        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("TimeDomain")]
        [TestMethod]
        public void SubscribeItemTest_Xml_Error_UnknownItemId()
        {
            SubscribeItemTest_Error(
                DALiveTestEnvironment.OpcFoundation_XmlDaSampleServer.ServerDescriptors.Http,
                "unknown_item");
        }
    }
}
