﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.AlarmsAndEvents.AddressSpace;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.AlarmsAndEvents.AddressSpace
{
    public partial class AENodeElementTest
    {
        [TestCategory("BinarySerialization")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        [NotNull]
        public AENodeElement CreateSerializationTarget0()
        {
            return new AENodeElement();
        }

        [NotNull]
        public AENodeElement CreateSerializationTarget1()
        {
            return new AENodeElement
            {
                HasChildren = true,
                IsArea = true,
                IsSource = false,
                QualifiedName = "TestQualifiedName",
                Name = "TestName"
            };
        }
    }
}
