﻿
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.DataTypeModel;
using OpcLabs.EasyOpc.UA.DataTypeModel;
using OpcLabs.EasyOpc.UA.DataTypeModel.Implementation;

namespace OpcLabs.EasyOpcTest.UA.DataTypeModel.Internal
{
    partial class DeveloperTest
    {
        #region Static Private Properties

        [NotNull]
        static private StructuredDataType IntegerArrayWithFixedLengthInBytesUnalignedDataType => new StructuredDataType("IntegerArrayWithFixedLengthInBytesUnaligned", "DeveloperTest:IntegerArrayWithFixedLengthInBytesUnaligned")
        {
            new DataField("Array", new SequenceDataType(UAOpcBinaryStandardDataTypes.Int32))
        };

        [NotNull]
        static private StructuredData IntegerArrayWithFixedLengthInBytesUnaligned_2Data => new StructuredData(IntegerArrayWithFixedLengthInBytesUnalignedDataType)
        {
            {
                "Array", new SequenceData(new SequenceDataType(UAOpcBinaryStandardDataTypes.Int32))
                {
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 161),
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 162)
                }
            }
        };

        [NotNull]
        static private StructuredData IntegerArrayWithFixedLengthInBytesUnaligned_3Data => new StructuredData(IntegerArrayWithFixedLengthInBytesUnalignedDataType)
        {
            {
                "Array", new SequenceData(new SequenceDataType(UAOpcBinaryStandardDataTypes.Int32))
                {
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 161),
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 162),
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 163)
                }
            }
        };

        [NotNull]
        static private byte[] IntegerArrayWithFixedLengthInBytesUnaligned_2ExtensionObjectBody => new byte[]
            {161, 0, 0, 0, 162, 0, 0, 0, 0, 0, 0, 0, 0};

        [NotNull]
        static private byte[] IntegerArrayWithFixedLengthInBytesUnaligned_3ExtensionObjectBody => new byte[]
            {161, 0, 0, 0, 162, 0, 0, 0, 163, 0, 0, 0, 0};

        [NotNull]
        static private byte[] IntegerArrayWithFixedLengthInBytesUnaligned_TooShortExtensionObjectBody => new byte[]
            {161, 0, 0, 0, 162, 0, 0, 0, 0};

        #endregion



        #region Test Methods

        [TestMethod]
        public void DecodeErrorTest_BinaryDecoderPrematureEndOfEncodedStream() =>
            DecodeErrorTest(null,
                TypeDictionaryByteArray,
                "IntegerArrayWithFixedLengthInBytesUnaligned",
                IntegerArrayWithFixedLengthInBytesUnaligned_TooShortExtensionObjectBody,
                new[] { UADataTypeModelErrorCodes.OpcBinarySystemDictionaryDecoderFailure, UADataTypeModelErrorCodes.OpcBinaryDictionaryDecoderPrematureEndOfEncodedStream});

        [TestMethod]
        public void DecodeTest_IntegerArrayWithFixedLengthInBytesUnaligned() =>
            DecodeTest(null,
                TypeDictionaryByteArray,
                "IntegerArrayWithFixedLengthInBytesUnaligned",
                IntegerArrayWithFixedLengthInBytesUnaligned_3ExtensionObjectBody,
                IntegerArrayWithFixedLengthInBytesUnaligned_3Data);

        [TestMethod]
        public void EncodeTest_IntegerArrayWithFixedLengthInBytesUnaligned() =>
            EncodeTest(null, 
                TypeDictionaryByteArray,
                "IntegerArrayWithFixedLengthInBytesUnaligned",
                IntegerArrayWithFixedLengthInBytesUnaligned_3Data,
                IntegerArrayWithFixedLengthInBytesUnaligned_3ExtensionObjectBody);

        [TestMethod]
        public void EncodeTest_IntegerArrayWithFixedLengthInBytesUnaligned_2() =>
            EncodeTest(null, 
                TypeDictionaryByteArray,
                "IntegerArrayWithFixedLengthInBytesUnaligned",
                IntegerArrayWithFixedLengthInBytesUnaligned_2Data,
                IntegerArrayWithFixedLengthInBytesUnaligned_2ExtensionObjectBody);

        #endregion
    }
}
