﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class UnifiedAutomation_UAGateway_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => new UANodeDescriptor[] { "nsu=urn:lt-mezhanne3:UnifiedAutomation:UaServerCpp/http://www.unifiedautomation.com/DemoServer/ ;ns=13;s=Demo.Static.Arrays.Int32" };

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "nsu=urn:lt-mezhanne3:UnifiedAutomation:UaServerCpp/http://www.unifiedautomation.com/DemoServer/ ;ns=13;s=Demo.Dynamic.Scalar.Float",
            "nsu=urn:UnifiedAutomation:DemoServer:lt-mezhanne3/http://www.unifiedautomation.com/DemoServer/ ;ns=25;s=Demo.Dynamic.Scalar.Float",
            "nsu=urn:UnifiedAutomation:DemoServer:lt-mezhanne3/http://www.unifiedautomation.com/DemoServer/ ;ns=25;s=Demo.Dynamic.Scalar.Double",
            "nsu=urn:UnifiedAutomation:DemoServer:lt-mezhanne3/http://www.unifiedautomation.com/DemoServer/ ;ns=25;s=Demo.Dynamic.Scalar.Int32",
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://lt-mezhanne3:48050" };

        public override string Password => "pwd";

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test03_ActivateSession_UserNameAndPassword),
            nameof(Group001_Session_Test09_CreateSession_Https_None),   // by me
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),
            nameof(Group003_AttributeServices_Test07_Write_Array_IndexRange),
            nameof(Group005_InformationModel_Test04_Browse_Read_SessionDiagnosticsArray),
            nameof(Group013_Discovery_Test03_FindServers_LDS_ServerPresence),
            //nameof(Group102_Session2_Test01_CreateSession_UaTcp_Basic256),
            //nameof(Group102_Session2_Test02_CreateSession_UaTcp_Basic256Sha256),
            //nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256)
        });

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[] { "nsu=urn:UnifiedAutomation:DemoServer:lt-mezhanne3/http://www.unifiedautomation.com/DemoServer/ ;ns=25;s=Demo.Static.Scalar.Int32" };

        public override string UserName => "user";

        public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[] { "nsu=urn:UnifiedAutomation:DemoServer:lt-mezhanne3/http://www.unifiedautomation.com/DemoServer/ ;ns=25;s=Demo.Static.Scalar.Int32" };
    }
}
